<template>
  <v-card>
	  
	  <v-toolbar
		dark
		color="brown"
		>
		<v-btn 
		icon
		dark
		v-on:click.native="close"
		>
			<v-icon>mdi-close</v-icon>
		</v-btn>
			<v-toolbar-title class="title white--text pl-0">
				Selamat Berdonasi di Crowd Funding Sahabat Kita!
			</v-toolbar-title>
		</v-toolbar>

	  <v-card-title>Rincian Donasi Anda</v-card-title>
	  <v-card-subtitle></v-card-subtitle>
	  <v-card-text>
		  <v-simple-table boder>
			  <thead>
				  	<tr>
						  <td>No.</td>
						  <td>Campaign</td>
						  <td>Alamat</td>
						  <td>Nominal Donasi</td>
						  <td>Action</td>
					</tr>
			  </thead>
			  <tbody>
				  <tr v-for="( donation, index ) in donations" v-bind:key="index">
					  <td>{{index+1}}</td>
					  <td>{{donation.campaign.title}}</td>
					  <td>{{donation.campaign.address}}</td>
					  <td>{{donation.amount.toLocaleString('id-ID')}}</td>
					  <td><v-btn v-on:click="doRemove(index)">hapus</v-btn></td>
				  </tr>
			  </tbody>
		  </v-simple-table>
		  	<v-card class="mt-4">
				<v-card-title>Ringkasan Donasi</v-card-title>
				<v-card-text>
					Jumlah Donasi Campaign: <v-chip>{{donations.length}}</v-chip>
					<v-divider></v-divider>
					Jumlah Donasi: <v-chip>Rp {{amount.toLocaleString('id-ID')}}</v-chip>
					<v-divider></v-divider>
					<v-select
						v-model="method"
						item-text="name"
						item-value="code"												  
						:items="methods"
						menu-props="auto"
						label="Pilih metode donasi via bank"
						return-object
						prepend-icon="mdi-bank"
						single-line
						required
					></v-select>
					<v-textarea v-model="naration"

						outlined
						name="input-1-2"
						label="Pesan Donasi"			

					>				  
					</v-textarea>

				</v-card-text>				
			</v-card>
	  </v-card-text>
	  <v-card-actions>
		<v-btn v-on:click="confirmationDialog=true" color="green darken-1">Bayar</v-btn>
	  </v-card-actions>
	  <alert/>
			<v-dialog
				v-model="confirmationDialog"
				persistent
				max-width="450"
				>
				<template v-if="confirmState">
					<v-card>
						<v-card-title class="headline">
							Konfirmasi Instruksi Pembayaran Donasi Melalui Virtual Account
						</v-card-title>
						<v-card-text>
							Dengan menekan tombol konfirmasi maka situs Crowd Funding akan mendapatkan Kode VA untuk melanjutkan pembayaran
						</v-card-text>
						<v-card-actions>
						<v-spacer></v-spacer>
							<v-btn color="red darken-1" @click="disagree" >Tidak Setuju</v-btn>
							<v-btn color="green darken-1" @click="processToServer">Setuju</v-btn>
						</v-card-actions>
					</v-card>
				</template>
				<template v-else>
					<v-card>
						<v-card-title class="headline">
							Informasi VA
						</v-card-title>
						<v-card-text>
							Nomor Referensi : {{response_data.reff_id}}
							<v-divider></v-divider>
							Transaction Id : {{response_data.midtrans_response.transaction_id}}
							<v-divider></v-divider>
							Bank Penerbit VA : {{response_data.midtrans_response.bank}}
							<v-divider></v-divider>
							Nomor VA : {{response_data.midtrans_response.va_number}}
						</v-card-text>
						<v-card-actions>													
							<v-btn color="green darken-1" @click="dismiss">Sudah mencatat dan memahami</v-btn>
						</v-card-actions>
					</v-card>	
				</template>
			</v-dialog>
  </v-card>
</template>

<script>
import alert from '../Alert.vue'
import {mapGetters, mapActions} from 'vuex'

export default {
	name:'tx-component',
	components:{
		alert
	},
	data(){
		return{
			total:0,
			naration:'',
			method:'',
			amount:0,
			methods:[
				{code:'bca',name:'Bank Central Asia (BCA)'},
				{code:'bni',name:'Bank Negara Indonesia (BNI)'},
				{code:'bri',name:'Bank Rakyat Indonesia (BRI)'},
				{code:'mandiri_bill',name:'Bank Mandiri (Mandiri)'},
				{code:'permata',name:'Bank Permata'}
			],
			confirmationDialog:false,
			confirmState:true,
			response_data:{}
		}
	},
	methods:{
		...mapActions({
			removeDonation:'donationTransaction/removeDonation',
			clearAllDonations:'donationTransaction/clear',
			alert:'alert/show'
		}),
		close:function(){
			this.$emit('closed',false)
		},
		totalAmount(){

			this.amount = parseInt(0)

			this.donations.forEach(donation => {
				this.amount += parseInt(donation.amount)
			});			
		},
		doRemove(index){

			this.removeDonation(index)
			this.totalAmount()
			
		},
		getForm(){
			let form = new FormData()

				form.append('method',this.method.code)
				form.append('naration',this.naration)
				form.append('amount',this.amount)
				form.append('campaigns', JSON.stringify(this.donations))
			
			return form
		},
		getHeader:function(){
			return{
				headers:{
					'Accept': 'application/json',
					'Access-Control-Allow-Headers': 'Authorization',
					Authorization:`Bearer ${this.token}`,
				}
			}
		},		
		processToServer(){

				console.log(`The value are ${this.method.code} - ${this.amount} - ${this.naration}`)

				axios.post('/api/transaction/store/transaction',this.getForm(),this.getHeader())

				.then((response) => {
					
					if(response.status==201){
					
					console.log('the response')

					let {response_code, response_message, data} = response.data 
					
						if(response_code==='00'){

							this.response_data = data
							this.confirmState = false
							this.alert({title:'success',message:`Permintaan VA Berhasil Mohon check VA di email atau layar berikut`})

						}else{

							this.alert({title:'error',message:`Permintaan VA Gagal : ${response.data.message}`})

							this.confirmationDialog = false

						}
					}else{
					
						this.alert({title:'error',message:`Permintaan VA Gagal VA Gagal !`})

						this.confirmationDialog = false

					}					

				}).catch((e) => {
					
					console.log(e);	

					let {errors, message} = e.response.data
					
					this.alert({
						title:'error',
						message:message,
						theErrors:errors													
					})

					this.confirmationDialog = false

				});

						
		},
		agree(){
			this.processToServer()
		},
		disagree(){
			this.confirmationDialog = false
		},dismiss(){
			this.confirmationDialog = false
			this.$emit('closed',false)
			this.clearAllDonations()
		}

	},
	computed:
	{
		...mapGetters({
			donations:'donationTransaction/donations',
			token:'authenticate/haveToken'
		}),
	},
	mounted(){
		this.totalAmount()
	}
}
</script>

<style>

</style>